//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46F407FE03C5.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46F407FE03C5.cm

//## begin module%46F407FE03C5.cp preserve=no
//## end module%46F407FE03C5.cp

//## Module: TableAccess%46F407FE03C5; Package specification
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/OGIPTable/TableAccess.h

#ifndef TABLEACCESS_H
#define TABLEACCESS_H 1

//## begin module%46F407FE03C5.additionalIncludes preserve=no
//## end module%46F407FE03C5.additionalIncludes

//## begin module%46F407FE03C5.includes preserve=yes
#include <xsTypes.h>
//## end module%46F407FE03C5.includes

//## begin module%46F407FE03C5.declarations preserve=no
//## end module%46F407FE03C5.declarations

//## begin module%46F407FE03C5.additionalDeclarations preserve=yes
namespace CCfits {
   class ExtHDU;
}
//## end module%46F407FE03C5.additionalDeclarations


//## begin TableAccess%46F40C30006E.preface preserve=yes
//## end TableAccess%46F40C30006E.preface

//## Class: TableAccess%46F40C30006E
//	Abstract Strategy pattern interface for performing table
//	model reads.
//## Category: XSModel::Model::Component::OGIPTable%3D2EE54A03A6
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class TableAccess 
{
  //## begin TableAccess%46F40C30006E.initialDeclarations preserve=yes
  //## end TableAccess%46F40C30006E.initialDeclarations

  public:
    //## Destructor (generated)
      virtual ~TableAccess();


    //## Other Operations (specified)
      //## Operation: clone%46F4258300B4
      virtual TableAccess* clone () = 0;

      //## Operation: initialRead%46F4281F01CC
      virtual void initialRead (CCfits::ExtHDU& spectraExt, const size_t nEngs, const size_t nAddPars, const bool isSameAsPrev) = 0;

      //## Operation: isError%46F4366D0065
      virtual bool isError () const = 0;

      //## Operation: isAddParamError%46F7F37E0101
      virtual const BoolArray& isAddParamError () const = 0;

      //## Operation: initialAccessRows%46F43A0D003B
      virtual void initialAccessRows (const IntegerArray& rowNumbers, const size_t nAddPars) = 0;

      //## Operation: getSpectrumEntries%46F438E70370
      virtual void getSpectrumEntries (const size_t iEng, Real* values) = 0;

      //## Operation: getVarianceEntries%46F43C99033C
      virtual void getVarianceEntries (const size_t iEng, Real* values) = 0;

      //## Operation: getAddSpectra%46F4428E0200
      virtual void getAddSpectra (const size_t iEng, const size_t iAdd, Real* values) = 0;

      //## Operation: getAddVariance%46F442D80185
      virtual void getAddVariance (const size_t iEng, const size_t iAdd, Real* values) = 0;

    // Additional Public Declarations
      //## begin TableAccess%46F40C30006E.public preserve=yes
      //## end TableAccess%46F40C30006E.public

  protected:
    //## Constructors (generated)
      TableAccess();

      TableAccess(const TableAccess &right);

    // Additional Protected Declarations
      //## begin TableAccess%46F40C30006E.protected preserve=yes
      //## end TableAccess%46F40C30006E.protected

  private:
    //## Assignment Operation (generated)
      TableAccess & operator=(const TableAccess &right);

    // Additional Private Declarations
      //## begin TableAccess%46F40C30006E.private preserve=yes
      //## end TableAccess%46F40C30006E.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin TableAccess%46F40C30006E.implementation preserve=yes
      //## end TableAccess%46F40C30006E.implementation

};

//## begin TableAccess%46F40C30006E.postscript preserve=yes
//## end TableAccess%46F40C30006E.postscript

//## Class: TableValues%46FA9A3E012E
//	This class is meant to simply bundle the various
//	INTPSPEC  arrays into one convenient place.  It is
//	designed for SPEED and NOT SAFETY.  Hence the use of
//	C-style arrays and no bounds checking.  It is left up to
//	the user to allocate arrays of precisely size nSpecRows
//	if and when a particular member array is needed.
//## Category: XSModel::Model::Component::OGIPTable%3D2EE54A03A6
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Persistence: Transient
//## Cardinality/Multiplicity: n



struct TableValues 
{
    //## Constructors (generated)
      TableValues();

      TableValues(const TableValues &right);

    //## Destructor (generated)
      ~TableValues();

    //## Assignment Operation (generated)
      TableValues & operator=(const TableValues &right);


    //## Other Operations (specified)
      //## Operation: clearAll%4702531C029B
      void clearAll ();

    // Data Members for Class Attributes

      //## Attribute: interpValues%46FA9AC60151
      //## begin TableValues::interpValues%46FA9AC60151.attr preserve=no  public: std::vector<Real*> {U} 
      std::vector<Real*> m_interpValues;
      //## end TableValues::interpValues%46FA9AC60151.attr

      //## Attribute: interpValueError%46FA9ACC0216
      //## begin TableValues::interpValueError%46FA9ACC0216.attr preserve=no  public: std::vector<Real*> {U} 
      std::vector<Real*> m_interpValueError;
      //## end TableValues::interpValueError%46FA9ACC0216.attr

      //## Attribute: addSpectra%46FA9AD40020
      //## begin TableValues::addSpectra%46FA9AD40020.attr preserve=no  public: std::map<size_t,std::vector<Real*> > {U} 
      std::map<size_t,std::vector<Real*> > m_addSpectra;
      //## end TableValues::addSpectra%46FA9AD40020.attr

      //## Attribute: addSpectraError%46FA9AD90296
      //## begin TableValues::addSpectraError%46FA9AD90296.attr preserve=no  public: std::map<size_t,std::vector<Real*> > {U} 
      std::map<size_t,std::vector<Real*> > m_addSpectraError;
      //## end TableValues::addSpectraError%46FA9AD90296.attr

      //## Attribute: nSpecRows%47024FFB0070
      //## begin TableValues::nSpecRows%47024FFB0070.attr preserve=no  public: size_t {U} 
      size_t m_nSpecRows;
      //## end TableValues::nSpecRows%47024FFB0070.attr

  public:
  protected:
  private:

    //## Other Operations (specified)
      //## Operation: copy%46FA9CCF03C7
      void copy (const TableValues& right);

      //## Operation: swap%46FA9D3503C6
      void swap (TableValues& right);

  private: //## implementation
};

// Class TableAccess 

// Class TableValues 

//## begin module%46F407FE03C5.epilog preserve=yes
//## end module%46F407FE03C5.epilog


#endif
